package de.intevation.gnv.math;

import com.vividsolutions.jts.geom.Coordinate;

import java.util.Comparator;

/**
 * @author <a href="mailto:sascha.teichmann@intevation.de">Sascha L. Teichmann</a>
 */
public  class L1Comparator
implements    Comparator
{
    private Coordinate ref;

    public L1Comparator() {
    }

    public L1Comparator(Coordinate ref) {
        this.ref = ref;
    }

    public void setReference(Coordinate ref) {
        this.ref = ref;
    }

    public int compare(Object a, Object b) {
        Coordinate pa = (Coordinate)a;
        Coordinate pb = (Coordinate)b;
        double da = L1(ref, pa);
        double db = L1(ref, pb);
        if (da < db) return -1;
        if (da > db) return +1;
        return 0;
    }

    public static double L1(Coordinate a, Coordinate b) {
        return Math.abs(a.x - b.x) + Math.abs(a.y - b.y);
    }

}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
